//
//  ViewController.m
//  UCLBRTCardSDKDemo
//
//  Created by test on 2021/7/29.
//

#import "ViewController.h"
#import <UCLBRTCardSDK/UseCard.h>
@interface ViewController ()<UITableViewDelegate,UITableViewDataSource>
@property (weak, nonatomic) IBOutlet UITableView *uitableview;
@property(nonatomic,strong)NSString *mac;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor groupTableViewBackgroundColor];
    self.uitableview.backgroundColor = [UIColor clearColor];
    self.uitableview.dataSource = self;
    self.uitableview.delegate = self;
    self.uitableview.tableFooterView = [[UIView alloc]initWithFrame:CGRectZero];
    [[UseCard shareSingleton]registerSid:@"7db6d3b9f2bf616ce13cfe62ea0f0b4a" token:@"c8defa74208a15fc9d046ec1b7f0bd"];
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return 4;
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *ID = @"demoCell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:ID];
    if (!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:ID];
    }
    NSArray *titleArr = @[@"获取房卡mac地址",@"签发房卡",@"读取房卡",@"注销房卡"];
    cell.textLabel.text = titleArr[indexPath.row];
    return cell;
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 60;
}
-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    if (indexPath.row == 0) {
        [[UseCard shareSingleton]getMacWithCommunityNo:@"1316881677" resultBlock:^(NSString * _Nonnull mac, NSString * _Nonnull error) {
            if(!error){
                self.mac = mac;
            }
            UIAlertController *alert = [UIAlertController alertControllerWithTitle:error?@"错误":@"MAC地址为" message:error?error:mac preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *action = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                
            }];
            [alert addAction:action];
            [self presentViewController:alert animated:YES completion:nil];
        }];
    }else if (indexPath.row == 1){
        [[UseCard shareSingleton]makeCardWithCommunityNo:@"1316881677" buildNo:@"000" floorNo:@"002" roomNo:@"109房间" creatorPassword:@"gsz123456" mac:self.mac creatorMobile:@"15070412614" creatorEmail:nil creatorAreaCode:@"86" opentype:0 owner:nil ownerGender:nil ownerAreaCode:nil ownerMobile:nil resultBlock:^(NSString * _Nonnull error) {
            NSString *str = error?error:@"发卡成功";
            UIAlertController *alert = [UIAlertController alertControllerWithTitle:str message:nil preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *action = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                
            }];
            [alert addAction:action];
            [self presentViewController:alert animated:YES completion:nil];
            
        }];
    }else if (indexPath.row == 2){
        [[UseCard shareSingleton]readCardWithCommunityNo:@"1316881677" creatorPassword:@"gsz123456" mac:self.mac creatorMobile:@"15070412614" creatorEmail:nil creatorAreaCode:@"86" operateCardType:nil resultBlock:^(NSString * _Nonnull error, NSDictionary * _Nonnull infoDict) {
            UIAlertController *alert = [UIAlertController alertControllerWithTitle:error?error:[self dictionaryToJson:infoDict] message:nil preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *action = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                
            }];
            [alert addAction:action];
            [self presentViewController:alert animated:YES completion:nil];
        }];
    }else{
        [[UseCard shareSingleton]cancelCardWithResultBlock:^(NSString * _Nonnull error) {
            NSString *str = error?error:@"注销卡成功";
            UIAlertController *alert = [UIAlertController alertControllerWithTitle:str message:nil preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *action = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
                
            }];
            [alert addAction:action];
            [self presentViewController:alert animated:YES completion:nil];
        }];
    }
}
- (NSString*)dictionaryToJson:(NSDictionary *)dic
{
//    NSError *parseError = nil;
//    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:dic options:NSJSONWritingPrettyPrinted error:&parseError];
//
//    return [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
    
    return [NSString stringWithFormat:@"楼栋名称:%@\n楼栋编号:%@\n楼层名称:%@\n楼层编号:%@\n房间编号:%@\n开始时间:%@\n结束时间:%@\n卡序列号:%@\n卡类型:%@",dic[@"buildername"],dic[@"builderno"],dic[@"floorname"],dic[@"floorno"],dic[@"roomno"],dic[@"starttime"],dic[@"endtime"],dic[@"serialNum"],dic[@"cardtype"]];
}

@end
